"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var _default = createNodeIterator;
exports["default"] = _default;

function createNodeIterator(root) {
  var whatToShow = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0xFFFFFFFF;
  var filter = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
  return new NodeIterator(root, whatToShow, filter);
}

var NodeIterator = /*#__PURE__*/function () {
  function NodeIterator(root, whatToShow, filter) {
    _classCallCheck(this, NodeIterator);

    this.root = root;
    this.whatToShow = whatToShow;
    this.filter = filter;
    this.referenceNode = root;
    this.pointerBeforeReferenceNode = true;

    this._filter = function (node) {
      return filter ? filter(node) === 1 : true;
    };

    this._show = function (node) {
      return whatToShow >> node.nodeType - 1 & 1 === 1;
    };
  }

  _createClass(NodeIterator, [{
    key: "nextNode",
    value: function nextNode() {
      var node = this.referenceNode;
      var before = this.pointerBeforeReferenceNode;

      while (true) {
        if (before) {
          before = false;
        } else {
          if (node.firstChild) node = node.firstChild;else {
            do {
              if (node === this.root) return null;
              if (node.nextSibling) break;
              node = node.parentNode;
            } while (true);

            node = node.nextSibling;
          }
        }

        if (this._show(node) && this._filter(node)) break;
      }

      this.referenceNode = node;
      this.pointerBeforeReferenceNode = before;
      return node;
    }
  }, {
    key: "previousNode",
    value: function previousNode() {
      var before = this.pointerBeforeReferenceNode;
      var node = this.referenceNode;

      while (true) {
        if (!before) {
          before = true;
        } else {
          if (node === this.root) return null;

          if (node.previousSibling) {
            node = node.previousSibling;

            while (node.lastChild) {
              node = node.lastChild;
            }
          } else node = node.parentNode;
        }

        if (this._show(node) && this._filter(node)) break;
      }

      this.referenceNode = node;
      this.pointerBeforeReferenceNode = before;
      return node;
    }
  }, {
    key: "toString",
    value: function toString() {
      return '[object NodeIterator]';
    }
  }]);

  return NodeIterator;
}();
//# sourceMappingURL=implementation.js.map